leetcode每日一题(6/20)

2020 6/20

leetcode每日一题

题目

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。数组中同一个元素不能使用两遍。

 nums = [2, 7, 11, 15], target = 9
 
 nums[0] + nums[1] = 2 + 7 = 9
 
    返回 [0, 1]

解法一: 暴力法

暴力法很简单,遍历每个元素element,并查找是否存在一个值与 target−element相等的目标元素。

 public int[] twoSum(int[] nums, int target) {
        for (int i = 0; i < nums.length; i++) {
            for (int j = i + 1; j < nums.length; j++) {
                if (nums[j] == target - nums[i]) {
                    return new int[] { i, j };
                }
            }
        }
        throw new IllegalArgumentException("No two sum solution");
    }

时间复杂度:O(n^2)

空间复杂度:O(1)

 

 

解法二: 两遍哈希表

   public int[] twoSum(int[] nums, int target) {
        Map map = new HashMap<>();
        for (int i = 0; i < nums.length; i++) {
            map.put(nums[i], i);
        }
        for (int i = 0; i < nums.length; i++) {
            int complement = target - nums[i];
            if (map.containsKey(complement) && map.get(complement) != i) {
                return new int[] { i, map.get(complement) };
            }
        }
        throw new IllegalArgumentException("No two sum solution");
    }

时间复杂度:O(n),

空间复杂度:O(n),

 

解法三: 一遍哈希表

    public int[] twoSum(int[] nums, int target) {
        Map map = new HashMap<>();
        for (int i = 0; i < nums.length; i++) {
            int complement = target - nums[i];
            if (map.containsKey(complement)) {
                return new int[] { map.get(complement), i };
            }
            map.put(nums[i], i);
        }
        throw new IllegalArgumentException("No two sum solution");
    }

时间复杂度:O(n),

空间复杂度:O(n),

 

解法二和解法三没有问题.

如果有重复元素, 并且target是这两个重复元素的和, 比如 {4,2,3,4}, 求8,

解法2:

  第二个4会把第一个4的坐标覆盖掉, 变成map.get(4) = 3

  因为再次遍历的时候是从0开始, 所以会先遍历前面的4, 但是获取的坐标是后面的坐标, 所以满足条件.

解法3:

  遍历到第一个4的时候, 会把4的坐标存进map, 遍历到第二个4的时候, 不会存, 直接就返回结果了

你可能感兴趣的:(Java数据结构和算法,Java)